searchNodes=[{"ref":"BtrzAuth.html","title":"BtrzAuth","type":"module","doc":"BtrzAuth is the authentication api for the Betterez Elixir APIs."},{"ref":"BtrzAuth.html#internal_auth_token/1","title":"BtrzAuth.internal_auth_token/1","type":"function","doc":"Generates an internal token using the configuration main or secondary secret keys. It will return a token using the issuer passed by configuration and %{} claims. Options: issuer - the issuer of the token main_secret - main secret key secondary_secret - secondary secret key"},{"ref":"BtrzAuth.html#user_auth_token/2","title":"BtrzAuth.user_auth_token/2","type":"function","doc":"Generates an user token using the configuration secret keys. Options: issuer - the issuer of the token secret - secret key claims - custom claims for your token. Default %{}."},{"ref":"BtrzAuth.Audiences.html","title":"BtrzAuth.Audiences","type":"module","doc":""},{"ref":"BtrzAuth.Audiences.html#valid_audiences/0","title":"BtrzAuth.Audiences.valid_audiences/0","type":"function","doc":""},{"ref":"BtrzAuth.Audiences.html#valid_audiences_map/0","title":"BtrzAuth.Audiences.valid_audiences_map/0","type":"function","doc":""},{"ref":"BtrzAuth.Guardian.Plug.html","title":"BtrzAuth.Guardian.Plug","type":"module","doc":""},{"ref":"BtrzAuth.Guardian.Plug.html#authenticated?/2","title":"BtrzAuth.Guardian.Plug.authenticated?/2","type":"function","doc":""},{"ref":"BtrzAuth.Guardian.Plug.html#clear_remember_me/2","title":"BtrzAuth.Guardian.Plug.clear_remember_me/2","type":"function","doc":""},{"ref":"BtrzAuth.Guardian.Plug.html#current_claims/2","title":"BtrzAuth.Guardian.Plug.current_claims/2","type":"function","doc":""},{"ref":"BtrzAuth.Guardian.Plug.html#current_resource/2","title":"BtrzAuth.Guardian.Plug.current_resource/2","type":"function","doc":""},{"ref":"BtrzAuth.Guardian.Plug.html#current_token/2","title":"BtrzAuth.Guardian.Plug.current_token/2","type":"function","doc":""},{"ref":"BtrzAuth.Guardian.Plug.html#implementation/0","title":"BtrzAuth.Guardian.Plug.implementation/0","type":"function","doc":""},{"ref":"BtrzAuth.Guardian.Plug.html#put_current_claims/3","title":"BtrzAuth.Guardian.Plug.put_current_claims/3","type":"function","doc":""},{"ref":"BtrzAuth.Guardian.Plug.html#put_current_resource/3","title":"BtrzAuth.Guardian.Plug.put_current_resource/3","type":"function","doc":""},{"ref":"BtrzAuth.Guardian.Plug.html#put_current_token/3","title":"BtrzAuth.Guardian.Plug.put_current_token/3","type":"function","doc":""},{"ref":"BtrzAuth.Guardian.Plug.html#put_session_token/3","title":"BtrzAuth.Guardian.Plug.put_session_token/3","type":"function","doc":""},{"ref":"BtrzAuth.Guardian.Plug.html#remember_me/4","title":"BtrzAuth.Guardian.Plug.remember_me/4","type":"function","doc":""},{"ref":"BtrzAuth.Guardian.Plug.html#remember_me_from_token/4","title":"BtrzAuth.Guardian.Plug.remember_me_from_token/4","type":"function","doc":""},{"ref":"BtrzAuth.Guardian.Plug.html#sign_in/4","title":"BtrzAuth.Guardian.Plug.sign_in/4","type":"function","doc":""},{"ref":"BtrzAuth.Guardian.Plug.html#sign_out/2","title":"BtrzAuth.Guardian.Plug.sign_out/2","type":"function","doc":""},{"ref":"BtrzAuth.GuardianUser.Plug.html","title":"BtrzAuth.GuardianUser.Plug","type":"module","doc":""},{"ref":"BtrzAuth.GuardianUser.Plug.html#authenticated?/2","title":"BtrzAuth.GuardianUser.Plug.authenticated?/2","type":"function","doc":""},{"ref":"BtrzAuth.GuardianUser.Plug.html#clear_remember_me/2","title":"BtrzAuth.GuardianUser.Plug.clear_remember_me/2","type":"function","doc":""},{"ref":"BtrzAuth.GuardianUser.Plug.html#current_claims/2","title":"BtrzAuth.GuardianUser.Plug.current_claims/2","type":"function","doc":""},{"ref":"BtrzAuth.GuardianUser.Plug.html#current_resource/2","title":"BtrzAuth.GuardianUser.Plug.current_resource/2","type":"function","doc":""},{"ref":"BtrzAuth.GuardianUser.Plug.html#current_token/2","title":"BtrzAuth.GuardianUser.Plug.current_token/2","type":"function","doc":""},{"ref":"BtrzAuth.GuardianUser.Plug.html#implementation/0","title":"BtrzAuth.GuardianUser.Plug.implementation/0","type":"function","doc":""},{"ref":"BtrzAuth.GuardianUser.Plug.html#put_current_claims/3","title":"BtrzAuth.GuardianUser.Plug.put_current_claims/3","type":"function","doc":""},{"ref":"BtrzAuth.GuardianUser.Plug.html#put_current_resource/3","title":"BtrzAuth.GuardianUser.Plug.put_current_resource/3","type":"function","doc":""},{"ref":"BtrzAuth.GuardianUser.Plug.html#put_current_token/3","title":"BtrzAuth.GuardianUser.Plug.put_current_token/3","type":"function","doc":""},{"ref":"BtrzAuth.GuardianUser.Plug.html#put_session_token/3","title":"BtrzAuth.GuardianUser.Plug.put_session_token/3","type":"function","doc":""},{"ref":"BtrzAuth.GuardianUser.Plug.html#remember_me/4","title":"BtrzAuth.GuardianUser.Plug.remember_me/4","type":"function","doc":""},{"ref":"BtrzAuth.GuardianUser.Plug.html#remember_me_from_token/4","title":"BtrzAuth.GuardianUser.Plug.remember_me_from_token/4","type":"function","doc":""},{"ref":"BtrzAuth.GuardianUser.Plug.html#sign_in/4","title":"BtrzAuth.GuardianUser.Plug.sign_in/4","type":"function","doc":""},{"ref":"BtrzAuth.GuardianUser.Plug.html#sign_out/2","title":"BtrzAuth.GuardianUser.Plug.sign_out/2","type":"function","doc":""},{"ref":"BtrzAuth.Phoenix.Socket.Plug.html","title":"BtrzAuth.Phoenix.Socket.Plug","type":"module","doc":""},{"ref":"BtrzAuth.Phoenix.Socket.Plug.html#authenticated?/2","title":"BtrzAuth.Phoenix.Socket.Plug.authenticated?/2","type":"function","doc":""},{"ref":"BtrzAuth.Phoenix.Socket.Plug.html#clear_remember_me/2","title":"BtrzAuth.Phoenix.Socket.Plug.clear_remember_me/2","type":"function","doc":""},{"ref":"BtrzAuth.Phoenix.Socket.Plug.html#current_claims/2","title":"BtrzAuth.Phoenix.Socket.Plug.current_claims/2","type":"function","doc":""},{"ref":"BtrzAuth.Phoenix.Socket.Plug.html#current_resource/2","title":"BtrzAuth.Phoenix.Socket.Plug.current_resource/2","type":"function","doc":""},{"ref":"BtrzAuth.Phoenix.Socket.Plug.html#current_token/2","title":"BtrzAuth.Phoenix.Socket.Plug.current_token/2","type":"function","doc":""},{"ref":"BtrzAuth.Phoenix.Socket.Plug.html#implementation/0","title":"BtrzAuth.Phoenix.Socket.Plug.implementation/0","type":"function","doc":""},{"ref":"BtrzAuth.Phoenix.Socket.Plug.html#put_current_claims/3","title":"BtrzAuth.Phoenix.Socket.Plug.put_current_claims/3","type":"function","doc":""},{"ref":"BtrzAuth.Phoenix.Socket.Plug.html#put_current_resource/3","title":"BtrzAuth.Phoenix.Socket.Plug.put_current_resource/3","type":"function","doc":""},{"ref":"BtrzAuth.Phoenix.Socket.Plug.html#put_current_token/3","title":"BtrzAuth.Phoenix.Socket.Plug.put_current_token/3","type":"function","doc":""},{"ref":"BtrzAuth.Phoenix.Socket.Plug.html#put_session_token/3","title":"BtrzAuth.Phoenix.Socket.Plug.put_session_token/3","type":"function","doc":""},{"ref":"BtrzAuth.Phoenix.Socket.Plug.html#remember_me/4","title":"BtrzAuth.Phoenix.Socket.Plug.remember_me/4","type":"function","doc":""},{"ref":"BtrzAuth.Phoenix.Socket.Plug.html#remember_me_from_token/4","title":"BtrzAuth.Phoenix.Socket.Plug.remember_me_from_token/4","type":"function","doc":""},{"ref":"BtrzAuth.Phoenix.Socket.Plug.html#sign_in/4","title":"BtrzAuth.Phoenix.Socket.Plug.sign_in/4","type":"function","doc":""},{"ref":"BtrzAuth.Phoenix.Socket.Plug.html#sign_out/2","title":"BtrzAuth.Phoenix.Socket.Plug.sign_out/2","type":"function","doc":""},{"ref":"BtrzAuth.Providers.InternalToken.html","title":"BtrzAuth.Providers.InternalToken","type":"module","doc":"InternalTokenToken will generate tokens for internal services authentication"},{"ref":"BtrzAuth.Providers.InternalToken.html#get_token/1","title":"BtrzAuth.Providers.InternalToken.get_token/1","type":"function","doc":"Gets a token with the internal options"},{"ref":"BtrzAuth.Providers.UserToken.html","title":"BtrzAuth.Providers.UserToken","type":"module","doc":"UserToken will generate tokens for users authentication"},{"ref":"BtrzAuth.Providers.UserToken.html#get_token/2","title":"BtrzAuth.Providers.UserToken.get_token/2","type":"function","doc":"Gets a token for the user with the options. Options may include: secret - secret key for generating your token. claims - custom claims for your token. Default %{}."},{"ref":"BtrzAuth.Plug.AddPremiumFromProviders.html","title":"BtrzAuth.Plug.AddPremiumFromProviders","type":"module","doc":"Looks for the provider_ids in the query params and fetchs its premium keys using account data under conn.private.account saved by BtrzAuth.Plug.VerifyApiKey (the order of the plugs is very important!) This plug will look for providerId or provider_id or a list of comma separated ids in providerIds or provider_ids. This plug assumes that BtrzAuth.Plug.VerifyProviders already verified that the providers are valid for the account. If the passed provider/s have premium keys, these will be added to the ones of the conn.private.account. Example plug BtrzAuth.Plug.AddPremiumFromProviders"},{"ref":"BtrzAuth.Plug.AddPremiumFromProviders.html#call/2","title":"BtrzAuth.Plug.AddPremiumFromProviders.call/2","type":"function","doc":""},{"ref":"BtrzAuth.Plug.AddPremiumFromProviders.html#init/1","title":"BtrzAuth.Plug.AddPremiumFromProviders.init/1","type":"function","doc":""},{"ref":"BtrzAuth.Plug.VerifyApiKey.html","title":"BtrzAuth.Plug.VerifyApiKey","type":"module","doc":"Looks for and validates a token found in the x-api-key header requesting the accounts service to verify the token and saving the resource in conn.private[:account]. This, like all other Guardian plugs, requires a Guardian pipeline to be setup. It requires an error handler as error_handler. These can be set either: Upstream on the connection with plug Guardian.Pipeline Upstream on the connection with Guardian.Pipeline.{put_module, put_error_handler, put_key} Inline with an option of :module, :error_handler, :key If a token is found but is invalid, the error handler will be called with auth_error(conn, {:api_key_not_found, reason}) Once a token has been found, it will be matched against the database using the configured collection and property, if not found, the error handler will be called with auth_error(conn, {:account_not_found, reason}) Options: search_in - atom. The places to look for the x-api-key (:header, :query or :all). Defaults to: :all allow_blank - boolean. If set to true, will try to load a resource once the x-api-key is found, but will not fail if no resource is found. Defaults: false Example # default search and verify in all (header and query string) plug BtrzAuth.Plug.VerifyApiKey # search only in header plug BtrzAuth.Plug.VerifyApiKey, search_in: :header"},{"ref":"BtrzAuth.Plug.VerifyApiKey.html#call/2","title":"BtrzAuth.Plug.VerifyApiKey.call/2","type":"function","doc":""},{"ref":"BtrzAuth.Plug.VerifyApiKey.html#init/1","title":"BtrzAuth.Plug.VerifyApiKey.init/1","type":"function","doc":""},{"ref":"BtrzAuth.Plug.VerifyAudiences.html","title":"BtrzAuth.Plug.VerifyAudiences","type":"module","doc":"Looks for and validates that the passed audiences are present in the private data under conn.private.user_aud saved by BtrzAuth.Plug.VerifyToken (the order of the plugs is very important!) If the audiences are invalid, the pipeline will be halted and the conn.resp_body with: %{ &quot;error&quot; =&gt; &quot;unauthorized&quot;, &quot;reason&quot; =&gt; &quot;audiences_not_verified&quot; } Options: audiences - list of atom audiences to verify. Please use the ones found on BtrzAuth.Audiences.valid_audiences Example plug BtrzAuth.Plug.VerifyAudiences, audiences: [:CUSTOMER]"},{"ref":"BtrzAuth.Plug.VerifyAudiences.html#call/2","title":"BtrzAuth.Plug.VerifyAudiences.call/2","type":"function","doc":""},{"ref":"BtrzAuth.Plug.VerifyAudiences.html#init/1","title":"BtrzAuth.Plug.VerifyAudiences.init/1","type":"function","doc":""},{"ref":"BtrzAuth.Plug.VerifyPremium.html","title":"BtrzAuth.Plug.VerifyPremium","type":"module","doc":"Looks for and validates that the passed keys features are present in the account data under conn.private.account[&quot;premium&quot;] saved by BtrzAuth.Plug.VerifyApiKey (the order of the plugs is very important!) If the premium keys are not found under conn.private.account, the pipeline will be halted and the conn.resp_body with: %{ &quot;error&quot; =&gt; &quot;unauthorized&quot;, &quot;reason&quot; =&gt; &quot;premium_not_verified&quot; } Options: keys - list of atom premium features to verify. Defaults to: [] Example plug BtrzAuth.Plug.VerifyPremium, keys: [:special_content]"},{"ref":"BtrzAuth.Plug.VerifyPremium.html#call/2","title":"BtrzAuth.Plug.VerifyPremium.call/2","type":"function","doc":""},{"ref":"BtrzAuth.Plug.VerifyPremium.html#init/1","title":"BtrzAuth.Plug.VerifyPremium.init/1","type":"function","doc":""},{"ref":"BtrzAuth.Plug.VerifyProviders.html","title":"BtrzAuth.Plug.VerifyProviders","type":"module","doc":"Looks for and validates if there are provider_ids in the query params and if they are valids with the account data under conn.private.account saved by BtrzAuth.Plug.VerifyApiKey (the order of the plugs is very important!) This plug will look for providerId or provider_id or a list of comma separated ids in providerIds or provider_ids. This, like all other Guardian plugs, requires a Guardian pipeline to be setup. It requires an error handler as error_handler. These can be set either: Upstream on the connection with plug Guardian.Pipeline Upstream on the connection with Guardian.Pipeline.{put_module, put_error_handler, put_key} Inline with an option of :module, :error_handler, :key If any provider is invalid, the pipeline will be halted and an error with status 400 will be set in the conn.resp_body like this: %{ &quot;status&quot; =&gt; 400, &quot;code&quot; =&gt; &quot;INVALID_PROVIDER_ID&quot;, &quot;message&quot; =&gt; &quot;Error getting provider&quot; } Example plug BtrzAuth.Plug.VerifyProviders"},{"ref":"BtrzAuth.Plug.VerifyProviders.html#call/2","title":"BtrzAuth.Plug.VerifyProviders.call/2","type":"function","doc":""},{"ref":"BtrzAuth.Plug.VerifyProviders.html#init/1","title":"BtrzAuth.Plug.VerifyProviders.init/1","type":"function","doc":""},{"ref":"BtrzAuth.Plug.VerifyToken.html","title":"BtrzAuth.Plug.VerifyToken","type":"module","doc":"It depends on BtrzAuth.Plug.VerifyApiKey, looks for a token in the Authorization header and verify it using first the account&#39;s private key, if not valid, then main and secondary secrets provided by your app for internal token cases. In the case where: a. The session is not loaded b. A token is already found for :key This plug will not do anything. This, like all other Guardian plugs, requires a Guardian pipeline to be setup. It requires an error handler. These can be set either: Upstream on the connection with plug Guardian.Pipeline Upstream on the connection with Guardian.Pipeline.{put_module, put_error_handler, put_key} Inline with an option of :module, :error_handler, :key If a token is found but is invalid, the error handler will be called with auth_error(conn, {:invalid_token, reason}) Once a token has been found it will be decoded, the token and claims will be put onto the connection. They will be available using Guardian.Plug.current_claims/2 and Guardian.Plug.current_token/2 Options: claims - The literal claims to check to ensure that a token is valid realm - The prefix for the token in the Authorization header. Defaults to Bearer. :none will not use a prefix. key - The location to store the information in the connection. Defaults to: default Example # setup the upstream pipeline plug BtrzAuth.Plug.VerifyHeaderInternal, claims: %{typ: &quot;access&quot;} This will check the authorization header for a token Authorization Bearer: &lt;token&gt; This token will be placed into the connection depending on the key and can be accessed with Guardian.Plug.current_token and Guardian.Plug.current_claims OR MyApp.ImplementationModule.current_token and MyApp.ImplementationModule.current_claims"},{"ref":"BtrzAuth.Plug.VerifyToken.html#call/2","title":"BtrzAuth.Plug.VerifyToken.call/2","type":"function","doc":""},{"ref":"BtrzAuth.Plug.VerifyToken.html#init/1","title":"BtrzAuth.Plug.VerifyToken.init/1","type":"function","doc":""},{"ref":"BtrzAuth.Pipeline.ApiKeySecured.html","title":"BtrzAuth.Pipeline.ApiKeySecured","type":"module","doc":"This pipeline will: Check the x-api-key header is sent and load the implemented resource in conn.private[:account]. Validate the providers if passed via query params. Add the premium keys of the providers to the ones of the current account."},{"ref":"BtrzAuth.Pipeline.ApiKeySecured.html#call/2","title":"BtrzAuth.Pipeline.ApiKeySecured.call/2","type":"function","doc":"Callback implementation for Plug.call/2."},{"ref":"BtrzAuth.Pipeline.ApiKeySecured.html#init/1","title":"BtrzAuth.Pipeline.ApiKeySecured.init/1","type":"function","doc":"Callback implementation for Plug.init/1."},{"ref":"BtrzAuth.Pipeline.TokenSecured.html","title":"BtrzAuth.Pipeline.TokenSecured","type":"module","doc":"This pipeline will: Check the x-api-key header is sent and load the implemented resource in conn.private[:account]. Validate the providers if passed via query params. Add the premium keys of the providers to the ones of the current account. Verify the token with the private key or the configured main and secondary secret keys in case the token could be an internal one, then ensure authenticated."},{"ref":"BtrzAuth.Pipeline.TokenSecured.html#call/2","title":"BtrzAuth.Pipeline.TokenSecured.call/2","type":"function","doc":"Callback implementation for Plug.call/2."},{"ref":"BtrzAuth.Pipeline.TokenSecured.html#init/1","title":"BtrzAuth.Pipeline.TokenSecured.init/1","type":"function","doc":"Callback implementation for Plug.init/1."},{"ref":"BtrzAuth.Phoenix.SocketAuth.html","title":"BtrzAuth.Phoenix.SocketAuth","type":"module","doc":"This module should be used only by Phoenix Sockets."},{"ref":"BtrzAuth.Phoenix.SocketAuth.html#authenticate/2","title":"BtrzAuth.Phoenix.SocketAuth.authenticate/2","type":"function","doc":"Wraps the Guardian.Phoenix.Socket.authenticate using the BtrzAuth.Phoenix.Socket implementation module."},{"ref":"BtrzAuth.Services.Accounts.html","title":"BtrzAuth.Services.Accounts","type":"module","doc":""},{"ref":"BtrzAuth.Services.Accounts.html#get_account_auth_info/2","title":"BtrzAuth.Services.Accounts.get_account_auth_info/2","type":"function","doc":""},{"ref":"readme.html","title":"BtrzAuth","type":"extras","doc":"BtrzAuth Elixir package for authentication handling using Plug and Guardian (JWT). It supports X-API-KEY token and Authorization tokens, for external users or internal API communication."},{"ref":"readme.html#documentation","title":"BtrzAuth - Documentation","type":"extras","doc":"API documentation at HexDocs https://hexdocs.pm/btrz_ex_auth_api"},{"ref":"readme.html#installation","title":"BtrzAuth - Installation","type":"extras","doc":"If available in Hex, the package can be installed by adding btrz_auth to your list of dependencies in mix.exs: def deps do [{:btrz_ex_auth_api, &quot;~&gt; 0.7.0&quot;}] end Add your configuration config :btrz_ex_auth_api, :token, issuer: &quot;your-issuer&quot;, main_secret: &quot;YOUR_MAIN_KEY&quot;, secondary_secret: &quot;YOUR_SECONDARY_KEY&quot;"},{"ref":"readme.html#plugs","title":"BtrzAuth - Plugs","type":"extras","doc":"You can use the Guardian Plugs and the ones added by BtrzAuth: BtrzAuth.Plug.VerifyApiKey Looks for the header or querystring x-api-key and verify the account, saving it into conn.private[:account]. BtrzAuth.Plug.VerifyToken It depends on BtrzAuth.Plug.VerifyApiKey, looks for a token in the Authorization header and verify it using first the account&#39;s private key loading the user id in the conn.private[:user_id], if not valid, then main and secondary secrets provided by your app for internal token cases. BtrzAuth.Plug.VerifyPremium Looks for and validates that the passed keys features are present in the account data under conn.private.account[&quot;premium&quot;] saved by BtrzAuth.Plug.VerifyApiKey (the order of the plugs is very important!)"},{"ref":"readme.html#pipelines","title":"BtrzAuth - Pipelines","type":"extras","doc":"BtrzAuth.Pipeline.ApiKeySecured This pipeline will check the x-api-key header or querystring is sent and load the implemented resource in conn.private[:account]. plug BtrzAuth.Plug.VerifyApiKey BtrzAuth.Pipeline.TokenSecured This pipeline will check the x-api-key header loading the account data in conn.private[:account] and also the token with the private key or the configured main and secondary secret keys in case the token could be an internal one, then ensure authenticated and load the implemented resource id in the conn.private[:user_id]. plug BtrzAuth.Plug.VerifyApiKey plug BtrzAuth.Plug.VerifyToken plug Guardian.Plug.EnsureAuthenticated You can add pipelines in your Phoenix Router to get different authentication working. pipeline :token_secured do plug BtrzAuth.Pipelines.TokenSecured end scope &quot;/&quot; do pipe_through :token_secured # your routes here... end"},{"ref":"readme.html#phoenix-channels","title":"BtrzAuth - Phoenix Channels","type":"extras","doc":"For Phoenix socket auth we wrap the Guardian.Phoenix.Socket module in order to use our internal-token, you might add to your user_socket.ex: def connect(%{&quot;token&quot; =&gt; token}, socket) do case BtrzAuth.Phoenix.SocketAuth.authenticate(socket, token) do {:ok, authed_socket} -&gt; {:ok, authed_socket} {:error, _} -&gt; :error end end def connect(_params, _socket) do :error end"},{"ref":"readme.html#integration-tests-in-your-api","title":"BtrzAuth - Integration tests in your API","type":"extras","doc":"Add the test_resource in order to test your endpoints once the plugs or pipelines are defined: config :btrz_ex_auth_api, :token, issuer: &quot;your-issuer&quot;, main_secret: &quot;YOUR_MAIN_KEY&quot;, secondary_secret: &quot;YOUR_SECONDARY_KEY&quot; test_resource: %{account_id: &quot;DESIRED_ID&quot;} and use &quot;test-token&quot; as your test token in the Authorization header. Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/btrz_auth."}]